/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "../../memsl.h"
#include "vedt.h"

/***************************************************************************\
**
\***************************************************************************/
void InitTabs(char *tabstr, int maxstr, int tabspec)
  {
    int i;

    *(tabstr+maxstr-1) = '\0';
    memset(tabstr,' ',maxstr-1);
    for (i = 0; i < maxstr-1; i++)
      if (i % tabspec == tabspec-1) *(tabstr+i) = 'T';
  }

/***************************************************************************\
**
\***************************************************************************/
void Detab(char *str1, char *str2, int maxlen, char *tabstr)
  {
    char *strptr1 = str1, *strptr2 = str2;
    int i, len = 0;

    while (len < maxlen && *strptr1)
      {
        if (*strptr1 == '\t')
          {
            *strptr2 = '\0';
            i = (int) strchr(tabstr+strlen(str2),'T') - (int) (tabstr+strlen(str2)) + 1;
            while (len < maxlen && i--)
              {
                *(strptr2++) = ' ';
                len++;
              }
          }
        else
          {
            *(strptr2++) = *strptr1;
            len++;
          }
        strptr1++;
      }
    *strptr2 = '\0';
  }

/***************************************************************************\
**
\***************************************************************************/
void Entab(char *str1, char *str2, int maxlen, char *tabstr)
  {
    int i, strip_on = 0;

    for (i = 0; i < strlen(str1); i++)
      {
        str2[i] = str1[i];
        if (tabstr[i] == 'T' && str2[i] == ' ' && str2[i-1] == ' ')
          str2[i] = '\t';
      }
    i = strlen(str2);
    while (i--)
      {
        if (str2[i] == '\t')
          strip_on = 1;
        else if (strip_on && str2[i] == ' ')
          strcpy(&str2[i],&str2[i+1]);
        else
          strip_on = 0;
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void DelFunct(void *nullitem, void *item)
  {
    if (nullitem);
    free(item);
  }

/***************************************************************************\
**
\***************************************************************************/
void *CopyFunct(void *nullitem, char *item)
  {
    char *ritem;

    if (nullitem);
    if ((ritem = malloc(strlen(item+1)+2)) != NULL)
      strcpy(ritem+1,item+1);
    return(ritem);
  }

/***************************************************************************\
**
\***************************************************************************/
char *UpdateCurrent(EDITOR *editor)
  {
    char *newstr = editor->strptr;

    if (*(editor->str+1) && *(editor->str+strlen(editor->str+1)) == ' ')
      {
        editor->realloc = 1;
        while (*(editor->str+1) && *(editor->str+strlen(editor->str+1)) == ' ')
            *(editor->str+strlen(editor->str+1)) = '\0';
      }
    if (editor->realloc)
      {
        if ((newstr = malloc(strlen(editor->str+1)+2)) != NULL)
          {
            strcpy(newstr+1,editor->str+1);
            editor->strptr = newstr;
            WBDListAdd(editor->dlist,newstr,WB_CURRENT);
          }
      }
    else strcpy(editor->strptr+1,editor->str+1);

    editor->changed = editor->realloc = 0;
    editor->chgmade = 1;
    return(newstr);
  }

/***************************************************************************\
**
\***************************************************************************/
char *UpdateLine(WBDLIST *dlist, char *str, int realloc)
  {
    char *newstr = str, *strptr;

    if (*(str+1) && *(str+strlen(str+1)) == ' ')
      {
        realloc = 1;
        while (*(str+1) && *(str+strlen(str+1)) == ' ')
            *(str+strlen(str+1)) = '\0';
      }
    if (realloc && (newstr = malloc(strlen(str+1)+2)) != NULL)
      {
        strcpy(newstr+1,str+1);
        WBDListAdd(dlist,newstr,WB_CURRENT);
      }
    else if ((strptr = WBDListGet(dlist,WB_CURRENT)) != NULL)
      strcpy(strptr+1,str+1);

    return(newstr);
  }

/***************************************************************************\
**
\***************************************************************************/
void LineMove(EDITOR *editor)
  {
    editor->strptr = WBDListGet(editor->dlist,WB_CURRENT);
    strcpy(editor->str+1,editor->strptr+1);
  }

/***************************************************************************\
**
\***************************************************************************/
void ResetOffsetPos(EDITOR *editor)
  {

    if ((editor->offset+editor->pos) > (int) strlen(editor->str+1))
      {
        memset(editor->str+1+strlen(editor->str+1),' ',(editor->offset+editor->pos)-strlen(editor->str+1));
        *(editor->str+1+editor->offset+editor->pos) = '\0';
      }
    else
      {
        while (*(editor->str+1) && *(editor->str+strlen(editor->str+1)) == ' '
          && editor->offset+editor->pos < (int) strlen(editor->str+1))
          *(editor->str+strlen(editor->str+1)) = '\0';
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void MoveToLine(EDITOR *editor, WBDLIST *lineptr)
  {
    WBDLIST *listptr, *topptr;
    int row = editor->row;
    long linenum = editor->linenum;

    if ((listptr = WBDListPointer(editor->dlist)) != NULL)
      if ((topptr = WBDListPointer(editor->dltopscr)) != NULL)
        {
          while (row < MAXROW-1
            && WBDListIsPtrEqual(listptr,lineptr) == 0
            && (WBDListIs(listptr)&WB_LAST) != WB_LAST)
            {
              WBDListGet(listptr,WB_NEXT);
              linenum++;
              row++;
            }
          if (WBDListIsPtrEqual(listptr,lineptr) == 0)
            while (row > 0
              && WBDListIsPtrEqual(listptr,lineptr) == 0
              && (WBDListIs(listptr)&WB_FIRST) != WB_FIRST)
              {
                WBDListGet(listptr,WB_PREV);
                linenum--;
                row--;
              }
          if (WBDListIsPtrEqual(listptr,lineptr) == 0)
            {
              row = 0;
              linenum = 0;
              WBDListGet(listptr,WB_FIRST);
              WBDListGet(topptr,WB_FIRST);
              while (WBDListIsPtrEqual(listptr,lineptr) == 0
                && (WBDListIs(listptr)&WB_LAST) != WB_LAST)
                {
                  WBDListGet(listptr,WB_NEXT);
                  linenum++;
                  if (row < (MAXROW-1)/2)
                    row++;
                  else
                    WBDListGet(topptr,WB_NEXT);
                }
            }
          if (WBDListIsPtrEqual(listptr,lineptr))
            {
              WBDListSetPtrEqual(editor->dlist,listptr);
              WBDListSetPtrEqual(editor->dltopscr,topptr);
              editor->row = row;
              editor->linenum = linenum;
              LineMove(editor);
              UpdateCoordinates(editor,0,MAXROW-1);
            }
          WBDListClose(listptr);
          WBDListClose(topptr);
        }
      else WBDListClose(listptr);
  }

