/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <malloc.h>
#include <string.h>
#include <io.h>

#include "../../memsl.h"
#include "port.h"
#include "vedt.h"

/***************************************************************************\
**
\***************************************************************************/
WBDLIST *GetFile(EDITOR *editor, char *filename)
  {
    WBDLIST *dlist = (WBDLIST *) 0;
    FILE *file;
    char str[MAXSTR+1], tmpstr[MAXSTR+1], *tmpptr;
    int done = 0;
    long lines = 0;

    if ((dlist = WBDListOpen(NULL)) != NULL)
      {
        WBDListDeleteF(dlist,NULL,(void (*)())DelFunct);
        WBDListCopyF(dlist,NULL,(void *(*)())CopyFunct);
        if ((file = fopen(filename,"rt")) != NULL)
          {
            scrprintf("Loading .");
            while (! done && fgets(str,MAXSTR-1,file))
              {
                if (*str && *(str+strlen(str)-1) == '\n')
                  *(str+strlen(str)-1) = '\0';
                Detab(str,tmpstr,MAXSTR-3,editor->tabstr);
                if ((tmpptr = malloc(strlen(tmpstr)+2)) != NULL)
                  {
                    strcpy(tmpptr+1,tmpstr);
                    if (WBDListAdd(dlist,tmpptr,WB_LAST) == 0)
                      {
                        free(tmpptr);
                        done = 1;
                      }
                  }
                else done = 1;
                lines++;
                if ((lines%100) == 0)
                  scrprintf(".");
              }
            if (done)
              {
                WBDListClose(dlist);
                dlist = (WBDLIST *) 0;
              }
            fclose(file);
          }
        else
          {
            if ((tmpptr = malloc(2)) != NULL)
              {
                *tmpptr = 0;
                *(tmpptr+1) = '\0';
                WBDListAdd(dlist,tmpptr,WB_LAST);
              }
          }
      }
    return(dlist);
  }

/***************************************************************************\
**
\***************************************************************************/
void PutFile(EDITOR *editor, WBDLIST *dlist, char *filename, int backup)
  {
    WBDLIST *pointer;
    FILE *file;
    char *strptr, tmpstr[MAXSTR+1], backupfile[MAXSTR+1];
    int i = 0;
    long lines = 0, chars = 0;

    if (backup)
      {
        strcpy(backupfile,filename);
        if (strchr(backupfile,'.'))
          *(strchr(backupfile,'.')) = '\0';
        strcat(backupfile,".bak");
        while (i < 99 && access(backupfile,0) == 0)
          sprintf(strchr(backupfile,'.')+2,"%02d",++i);
        scrprintf("Moved %s to %s\n\r",filename,backupfile);
        rename(filename,backupfile);
      }
    scrprintf("Writing .",filename);
    if ((file = fopen(filename,"wt")) != NULL)
      {
        if ((pointer = WBDListPointer(dlist)) != NULL)
          {
            strptr = WBDListGet(pointer,WB_FIRST);
            while (strptr)
              {
                while (*(strptr+1) && *(strptr+1+strlen(strptr+1)-1) == ' ')
                  *(strptr+1+strlen(strptr+1)-1) = '\0';
                while (*(strptr+1) && *(strptr+1+strlen(strptr+1)-1) == '\n')
                  *(strptr+1+strlen(strptr+1)-1) = '\0';
                if (editor->entab)
                  Entab(strptr+1,tmpstr,MAXSTR-1,editor->tabstr);
                else
                  strcpy(tmpstr,strptr+1);
                fprintf(file,"%s\n",tmpstr);
                chars+=(strlen(strptr+1)+2);
                strptr = WBDListGet(pointer,WB_NEXT);
                lines++;
                if ((lines%100) == 0)
                  scrprintf(".");
              }
            WBDListClose(pointer);
          }
        fclose(file);
        scrprintf("\n\r\"%s\" %ld Lines, %ld Characters\n\r",filename,lines,chars);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void LoadFile(EDITOR *editor)
  {
    char newfile[MAXSTR+1], *strptr;

    normvideo();
    clrscr();
    scrprintf("** Load New File\n\r\n\r");
    scrprintf("Current Path: %s\n\r",editor->filename);
    scrprintf("New Filename: ");
    newfile[0] = (char) MAXSTR-2;
    cgets(newfile);

    strptr = newfile+2;
    while (*strptr)
      {
        if (*strptr == '\\')
          *strptr = '/';
        strptr++;
      }

    scrprintf("\n\r\n\r");
    EditCleanUp(editor);
    WBDListClose(editor->dlist);
    strcpy(editor->filename,newfile+2);
    if ((editor->dlist = GetFile(editor,editor->filename)) == NULL)
      {
        scrprintf("ERROR: Could not load file %s\n\r",newfile+2);
        scrprintf("Loading file \"noname\"\n\r\n\r");
        strcpy(editor->filename,"noname");
        unlink(editor->filename);
        if ((editor->dlist = GetFile(editor,editor->filename)) == NULL)
          {
            scrprintf("ERROR: Could not load file \"noname\"\n\r");
            scrprintf("Fatal: Aborting... ");
            exit(1);
          }
        scrprintf("Press any key. ");
        getch();
      }
    WBDListGet(editor->dlist,WB_FIRST);
    editor->dltopscr = WBDListPointer(editor->dlist);
    editor->linenum = editor->row = editor->offset = editor->pos = 0;
    InitEditor(editor);
    UpdateCoordinates(editor,0,MAXROW-1);
    editor->chgmade = 0;
  }

/***************************************************************************\
**
\***************************************************************************/
void SaveFile(EDITOR *editor)
  {
    if (editor->changed)
      UpdateCurrent(editor);
    clrscr();
    scrprintf("** Save File\n\r\n\r");
    PutFile(editor,editor->dlist,editor->filename,1);
    UpdateCoordinates(editor,0,MAXROW-1);
    editor->chgmade = 0;
  }

/***************************************************************************\
**
\***************************************************************************/
void SaveFileAs(EDITOR *editor)
  {
    char newfile[MAXSTR+1], *strptr;

    clrscr();
    scrprintf("** Save To New File\n\r\n\r");
    scrprintf("Current Path: %s\n\r",editor->filename);
    scrprintf("New Filename: ");
    newfile[0] = (char)MAXSTR-2;
    cgets(newfile);

    strptr = newfile+2;
    while (*strptr)
      {
        if (*strptr == '\\')
          *strptr = '/';
        strptr++;
      }

    scrprintf("\n\r");
    strcpy(editor->filename,newfile+2);
    if (editor->changed)
      UpdateCurrent(editor);
    PutFile(editor,editor->dlist,newfile+2,0);
    UpdateCoordinates(editor,0,MAXROW-1);
    UpdateStats(editor,1);
    editor->chgmade = 0;
  }

/***************************************************************************\
**
\***************************************************************************/
void ReadBlock(EDITOR *editor, char *filename)
  {
    WBDLIST *readbuffer;
    char newfile[MAXSTR+1], *strptr, *tmpstr;

    if (editor->dlistbuffer)
      {
        if (filename == NULL)
          {
            normvideo();
            clrscr();
            scrprintf("Read Block Filename: ");
            newfile[0] = (char) MAXSTR-2;
            cgets(newfile);
            filename = newfile+2;
          }
        WBDListDelete(editor->dlistbuffer,WB_CLEAR);
        *editor->charbuffer = 0;
        if ((readbuffer = GetFile(editor,filename)) != NULL)
          {
            WBDListAddList(editor->dlistbuffer,readbuffer,WB_FIRST,0);
            if ((strptr = WBDListGet(editor->dlistbuffer,WB_LAST)) != NULL)
              {
                if ((tmpstr = malloc(strlen(strptr+1)+3)) != NULL)
                  {
                    strcpy(tmpstr+1,strptr+1);
                    strcat(tmpstr+1,"\n");
                    WBDListAdd(editor->dlistbuffer,tmpstr,WB_CURRENT);
                  }
              }
            BlockInsert(editor);
            WBDListClose(readbuffer);
          }
      }
    UpdateCoordinates(editor,0,MAXROW-1);
  }

/***************************************************************************\
**
\***************************************************************************/
void WriteBlock(EDITOR *editor)
  {
    WBDLIST *copybuffer;
    char newfile[MAXSTR+1], *tmpptr;

    if (editor->p1 && editor->p2 && editor->hideblock == 0)
      {
        normvideo();
        clrscr();
        scrprintf("Write Block Filename: ");
        newfile[0] = (char) MAXSTR-2;
        cgets(newfile);

        BlockCopy(editor);
        if (editor->charbuffer && *editor->charbuffer)
          {
            if ((copybuffer = WBDListOpen(NULL)) != NULL)
              {
                WBDListDeleteF(copybuffer,NULL,(void (*)())DelFunct);
                if ((tmpptr = malloc(strlen(editor->charbuffer)+2)) != NULL)
                  {
                    strcpy(tmpptr+1,editor->charbuffer);
                    WBDListAdd(copybuffer,tmpptr,WB_LAST);
                  }
                PutFile(editor,copybuffer,newfile+2,1);
              }
          }
        else if (editor->dlistbuffer
          && (WBDListIs(editor->dlistbuffer)&WB_EMPTY) != WB_EMPTY)
            PutFile(editor,editor->dlistbuffer,newfile+2,1);

        UpdateCoordinates(editor,0,MAXROW-1);
      }
  }

