/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <conio.h>

#include "../../memsl.h"
#include "port.h"
#include "vedt.h"
#include "getkey.h"

int GetIndent(EDITOR *editor, int current)
  {
    WBDLIST *dlistptr;
    int indent = 0, done = 0;
    char *strptr;

    if (editor->indent)
      if (current)
	{
	  strptr = editor->str;
	  while (indent < editor->pos+editor->offset
	    && *(strptr+indent+1) && *(strptr+indent+1) == ' ')
	      indent++;
	}
      else
	{
	  if ((dlistptr = WBDListPointer(editor->dlist)) != NULL)
	    {
	      while (done == 0)
		{
		  indent = 0;
		  if ((strptr = (char *) WBDListGet(dlistptr,WB_PREV)) != NULL)
		    {
		      while (*(strptr+indent+1) && *(strptr+indent+1) == ' ')
			indent++;
		      if (*(strptr+indent+1) != 0
			&& indent < editor->pos+editor->offset)
			  done = 1;
		    }
		  else done = 1;
		}
	      WBDListClose(dlistptr);
	    }
	}
    return(indent);
  }

int SpacesToLeft(EDITOR *editor, int pos)
  {
    char *strptr;

    strptr = editor->str;
    while (*(strptr+pos) && *(strptr+pos) == ' ' && pos-1)
      pos--;
    return(pos-1 ? 0 : 1);
  }

/***************************************************************************\
**
\***************************************************************************/
void KeyEnter(EDITOR *editor)
  {
    int indent = 0, setp1 = 0, setp2 = 0;
    char *newstr;

    if (editor->insert || (WBDListIs(editor->dlist)&WB_LAST) == WB_LAST)
      {
	if (editor->insert == 0
	  && (WBDListIs(editor->dlist)&WB_LAST) == WB_LAST)
	    editor->pos = strlen(editor->str+1);

	if (editor->indent)
	  indent = GetIndent(editor,1);
	newstr = malloc(strlen(editor->str+1+editor->offset+editor->pos)+indent+2);
	if (editor->p1
	  && WBDListIsPtrEqual(editor->p1,editor->dlist)
	  && editor->offset+editor->pos < editor->p1pos)
	  {
	    setp1 = 1;
	    editor->p1pos-=(editor->offset+editor->pos)+indent;
	  }
	if (editor->p2
	  && WBDListIsPtrEqual(editor->p2,editor->dlist))
	  {
	    if (editor->offset+editor->pos < editor->p2pos)
	      {
		setp2 = 1;
		editor->p2pos-=(editor->offset+editor->pos)+indent;
	      }
	  }
	memset(newstr+1,' ',indent);
	strcpy(newstr+indent+1,editor->str+1+editor->offset+editor->pos);
	*(editor->str+1+editor->offset+editor->pos) = '\0';
	editor->changed = editor->realloc = 1;
	UpdateCurrent(editor);
	WBDListAdd(editor->dlist,newstr,WB_NEXT);
	if (setp1)
	  WBDListSetPtrEqual(editor->p1,editor->dlist);
	if (setp2)
	  WBDListSetPtrEqual(editor->p2,editor->dlist);
      }
    else
      {
	if (editor->changed)
	  UpdateCurrent(editor);
	WBDListGet(editor->dlist,WB_NEXT);
      }
    if (editor->p1)
      if (setp1 || editor->linenum < editor->p1line)
	editor->p1line++;
    if (editor->p2)
      if (setp2 || editor->linenum < editor->p2line)
	  editor->p2line++;
    editor->linenum++;
    if (editor->row < MAXROW-1)
      editor->row++;
    else
      {
	WBDListGet(editor->dltopscr,WB_NEXT);
	editor->deltop = 1;
      }
    editor->pos = indent;
    if (editor->offset)
      {
	editor->offset = 0;
	UpdateCoordinates(editor,0,MAXROW-1);
      }
    else if (editor->insert)
      UpdateCoordinates(editor,editor->row-1,MAXROW-1);
    LineMove(editor);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyUp(EDITOR *editor, int shift)
  {
    unsigned int ptrbits = 0;

    if ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR1;
	      SetBlock(editor);
	    }

	if (editor->changed)
	  UpdateCurrent(editor);

	editor->linenum--;
	WBDListGet(editor->dlist,WB_PREV);

	if (editor->row > 0)
	  editor->row--;
	else
	  {
	    WBDListGet(editor->dltopscr,WB_PREV);
	    editor->instop = 1;
	    UpdateCoordinates(editor,editor->row,editor->row);
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyPageUp(EDITOR *editor, int shift)
  {
    unsigned int ptrbits = 0;
    int i;

    if ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR1;
	      SetBlock(editor);
	    }

	if (editor->changed)
	  UpdateCurrent(editor);

	i = MAXROW;
	while (i && (WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
	  {
	    editor->linenum--;
	    WBDListGet(editor->dlist,WB_PREV);
	    if ((WBDListIs(editor->dltopscr)&WB_FIRST) != WB_FIRST)
	      WBDListGet(editor->dltopscr,WB_PREV);
	    else editor->row--;
	    i--;
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyControlPageUp(EDITOR *editor, int shift)
  {
    unsigned int ptrbits = 0;

    if ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR1;
	      SetBlock(editor);
	    }

	if (editor->changed)
	  UpdateCurrent(editor);
	while ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
	  WBDListGet(editor->dlist,WB_PREV);
	WBDListGet(editor->dltopscr,WB_FIRST);
	editor->row = 0;
	editor->linenum = 0;

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyDown(EDITOR *editor, int shift)
  {
    unsigned int ptrbits = 0;

    if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR2;
	      SetBlock(editor);
	    }

	if (editor->changed)
	  UpdateCurrent(editor);

	WBDListGet(editor->dlist,WB_NEXT);
	editor->linenum++;

	if (editor->row < MAXROW-1)
	  editor->row++;
	else
	  {
	    WBDListGet(editor->dltopscr,WB_NEXT);
	    editor->deltop = 1;
	    UpdateCoordinates(editor,editor->row,editor->row);
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyPageDown(EDITOR *editor, int shift)
  {
    unsigned int ptrbits = 0;
    int i;

    if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR2;
	      SetBlock(editor);
	    }

	if (editor->changed)
	  UpdateCurrent(editor);

	i = MAXROW;
	while (i && (WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
	  {
	    editor->linenum++;
	    WBDListGet(editor->dlist,WB_NEXT);
	    WBDListGet(editor->dltopscr,WB_NEXT);
	    i--;
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyControlPageDown(EDITOR *editor, int shift)
  {
    unsigned int ptrbits = 0;

    if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR2;
	      SetBlock(editor);
	    }

	if (editor->changed)
	  UpdateCurrent(editor);

	while ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
	  {
	    editor->linenum++;
	    WBDListGet(editor->dlist,WB_NEXT);
	    if (editor->row < MAXROW-1)
	      editor->row++;
	    else
	      WBDListGet(editor->dltopscr,WB_NEXT);
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyLeft(EDITOR *editor, int shift)
  {
    unsigned int ptrbits;
    int rval = 0;

    if (shift)
      if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	|| (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	{
	  ptrbits = PTR1;
	  SetBlock(editor);
	}

    if (editor->pos > 0)
      {
	editor->pos--;
	rval = 1;
      }
    else if (editor->offset > 0)
      {
	editor->offset--;
	UpdateCoordinates(editor,0,MAXROW-1);
	rval = 1;
      }
    else
      if ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
	if ((rval = KeyUp(editor,shift)) != 0)
	  KeyEnd(editor,shift);

    if (rval && shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
      SetBlkPtrs(editor,ptrbits);

    return(rval);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyControlLeft(EDITOR *editor, int shift)
  {
    unsigned int ptrbits;
    int refillscr = 0;
    int rval = 0;

    if (shift)
      if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	|| (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	{
	  ptrbits = PTR1;
	  SetBlock(editor);
	}

    if (editor->pos == 0 && editor->offset == 0)
      {
	if ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
	  if ((rval = KeyUp(editor,shift)) != 0)
	    KeyEnd(editor,shift);
      }

    while ((editor->offset > 0 || editor->pos > 0)
      && strchr(editor->delims,*(editor->str+1+editor->offset+editor->pos-1)))
      {
	if (editor->pos > 0)
	  editor->pos--;
	else if (editor->offset > 0)
	  {
	    editor->offset--;
	    refillscr = 1;
	  }
	rval = 1;
      }

    while ((editor->pos > 0 || editor->offset >> 0)
      && strchr(editor->delims,*(editor->str+1+editor->offset+editor->pos-1)) == NULL)
      {
	if (editor->pos > 0)
	  editor->pos--;
	else if (editor->offset > 0)
	  {
	    editor->offset--;
	    refillscr = 1;
	  }
	rval = 1;
      }

    if (refillscr)
      UpdateCoordinates(editor,0,MAXROW-1);

    if (rval && shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
      SetBlkPtrs(editor,ptrbits);

    return(rval);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyRight(EDITOR *editor, int shift)
  {
    unsigned int ptrbits;

    if ((editor->pos+editor->offset) < MAXSTR-1)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR2;
	      SetBlock(editor);
	    }

	if ((editor->pos+editor->offset) == (int) strlen(editor->str+1))
	  {
	    *(editor->str+1+editor->pos+editor->offset) = ' ';
	    *(editor->str+2+editor->pos+editor->offset) = '\0';
	  }

	if (editor->pos < MAXCOL-1)
	  editor->pos++;
	else
	  {
	    editor->offset++;
	    UpdateCoordinates(editor,0,MAXROW-1);
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);

	return(1);
      }

    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyControlRight(EDITOR *editor, int shift)
  {
    unsigned int ptrbits;
    int refillscr = 0;
    int rval = 0;

    if (shift)
      if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	|| (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	{
	  ptrbits = PTR2;
	  SetBlock(editor);
	}

    if (*(editor->str+1+editor->offset+editor->pos) == '\0')
      {
	if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
	  if ((rval = KeyDown(editor,shift)) != 0)
	    KeyHome(editor,shift);
      }
    else
      while (*(editor->str+1+editor->offset+editor->pos)
	&& strchr(editor->delims,*(editor->str+1+editor->offset+editor->pos)) == NULL)
	{
	  if (editor->pos < MAXCOL-1 && editor->pos < (int) strlen(editor->str+1+editor->offset))
	    editor->pos++;
	  else if (editor->pos < (int) strlen(editor->str+1+editor->offset))
	    {
	      editor->offset++;
	      refillscr = 1;
	    }
	  rval = 1;
	}

    while (*(editor->str+1+editor->offset+editor->pos)
      && strchr(editor->delims,*(editor->str+1+editor->offset+editor->pos)))
      {
	if (editor->pos < MAXCOL-1 && editor->pos < (int) strlen(editor->str+1+editor->offset))
	  editor->pos++;
	else if (editor->pos < (int) strlen(editor->str+1+editor->offset))
	  {
	    editor->offset++;
	    refillscr = 1;
	  }
	rval = 1;
      }

    if (refillscr)
      UpdateCoordinates(editor,0,MAXROW-1);

    if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
      SetBlkPtrs(editor,ptrbits);

    return(rval);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyDeleteEnd(EDITOR *editor)
  {
    char *tmpstr;
    int setp1 = 0, setp2 = 0;

    if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	tmpstr = WBDListGet(editor->dlist,WB_NEXT);
	if (strlen(editor->str+1)+strlen(tmpstr+1) < MAXSTR)
	  {
	    if (editor->p1
	      && WBDListIsPtrEqual(editor->p1,editor->dlist))
	      {
		editor->p1pos+=strlen(editor->str+1);
		setp1 = 1;
	      }

	    if (editor->p2
	      && WBDListIsPtrEqual(editor->p2,editor->dlist))
	      {
		editor->p2pos+=strlen(editor->str+1);
		setp2 = 1;
	      }

	    strcat(editor->str+1,tmpstr+1);
	    if ((WBDListIs(editor->dlist)&WB_LAST) == WB_LAST)
	      WBDListDelete(editor->dlist,WB_CURRENT);
	    else
	      {
		WBDListDelete(editor->dlist,WB_CURRENT);
		WBDListGet(editor->dlist,WB_PREV);
	      }

	    if (setp1)
	      WBDListSetPtrEqual(editor->p1,editor->dlist);

	    if (setp2)
	      WBDListSetPtrEqual(editor->p2,editor->dlist);

	    if (editor->p1)
	      if (setp1 || editor->linenum < editor->p1line)
		editor->p1line--;

	    if (editor->p2)
	      if (setp2 || editor->linenum < editor->p2line)
		  editor->p2line--;

	    editor->changed = editor->realloc = 1;
	    UpdateCoordinates(editor,editor->row,MAXROW-1);
	  }
	else WBDListGet(editor->dlist,WB_PREV);
        return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyDelete(EDITOR *editor)
  {
    if (*(editor->str+1+editor->offset+editor->pos) == '\0')
      return(KeyDeleteEnd(editor));
    else
      {
	if (editor->indent)
	  {
	    if ((editor->pos+editor->offset == 0
	      || SpacesToLeft(editor,editor->pos+editor->offset))
	      && *(editor->str+1+editor->pos+editor->offset) == ' ')
	      {
		while (*(editor->str+1+editor->pos+editor->offset)
		  && *(editor->str+1+editor->pos+editor->offset) == ' ')
		    strcpy(editor->str+1+editor->offset+editor->pos,editor->str+1+editor->offset+editor->pos+1);
	      }
	    else
	      strcpy(editor->str+1+editor->offset+editor->pos,editor->str+1+editor->offset+editor->pos+1);
	  }
	else
	  strcpy(editor->str+1+editor->offset+editor->pos,editor->str+1+editor->offset+editor->pos+1);
	if (editor->p1
	  && WBDListIsPtrEqual(editor->p1,editor->dlist)
	  && editor->offset+editor->pos < editor->p1pos)
	  editor->p1pos--;
	if (editor->p2
	  && WBDListIsPtrEqual(editor->p2,editor->dlist)
	  && editor->offset+editor->pos < editor->p2pos)
	    editor->p2pos--;

	if (editor->p1 && editor->p2
          && WBDListIsPtrEqual(editor->p1,editor->p2)
	  && editor->p1pos >= editor->p2pos)
	  CloseBlock(editor);
        editor->changed = editor->realloc = 1;
	UpdateCoordinates(editor,editor->row,editor->row);
	return(1);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyBackSpaceFirst(EDITOR *editor)
  {
    int settop = 0, refillscr = 0, setp1 = 0, setp2 = 0;
    char *tmpstr;

    if ((WBDListIs(editor->dlist)&WB_FIRST) != WB_FIRST)
      {
	if (WBDListIsPtrEqual(editor->dltopscr,editor->dlist))
	  settop = 1;

	if (editor->p1
	  && WBDListIsPtrEqual(editor->p1,editor->dlist))
	  setp1 = 1;

	if (editor->p2
	  && WBDListIsPtrEqual(editor->p2,editor->dlist))
	  setp2 = 1;

	if (editor->changed)
	  UpdateCurrent(editor);

	WBDListGet(editor->dlist,WB_PREV);
	LineMove(editor);

	tmpstr = WBDListGet(editor->dlist,WB_NEXT);
	if (strlen(editor->str+1)+strlen(tmpstr+1) < MAXSTR)
	  {
	    if (strlen(editor->str+1) > MAXCOL)
	      {
		editor->offset = (strlen(editor->str+1)-MAXCOL)+10;
		refillscr = 1;
	      }

	    editor->pos = strlen(editor->str+1+editor->offset);

	    if (editor->row > 0)
	      editor->row--;

	    editor->linenum--;
	    strcat(editor->str+1,tmpstr+1);

	    if ((WBDListIs(editor->dlist)&WB_LAST) == WB_LAST)
	      WBDListDelete(editor->dlist,WB_CURRENT);
	    else
	      {
		WBDListDelete(editor->dlist,WB_CURRENT);
		WBDListGet(editor->dlist,WB_PREV);
	      }

	    if (settop)
	      WBDListSetPtrEqual(editor->dltopscr,editor->dlist);

	    if (setp1)
	      {
		WBDListSetPtrEqual(editor->p1,editor->dlist);
		editor->p1pos+=strlen(editor->strptr+1);
	      }

	    if (setp2)
	      {
		WBDListSetPtrEqual(editor->p2,editor->dlist);
		editor->p2pos+=strlen(editor->strptr+1);
	      }

	    if (editor->p1)
	      if (setp1 || editor->linenum < editor->p1line)
		editor->p1line--;

	    if (editor->p2)
	      if (setp2 || editor->linenum < editor->p2line)
		  editor->p2line--;

	    editor->changed = editor->realloc = 1;
	    UpdateCoordinates(editor,refillscr?0:editor->row,MAXROW-1);
	  }
	else
	  LineMove(editor);

	return(1);
      }
    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
int KeyBackSpace(EDITOR *editor)
  {
    int indent = 1;

    if (editor->offset+editor->pos == 0)
      return(KeyBackSpaceFirst(editor));
    else
      {
	if (editor->indent && SpacesToLeft(editor,editor->pos+editor->offset))
	  {
	    indent = GetIndent(editor,0);
	    indent = editor->pos+editor->offset-indent;
	  }
	strcpy(editor->str+1+editor->pos+editor->offset-indent,editor->str+1+editor->offset+editor->pos);

	if (editor->p1
	  && WBDListIsPtrEqual(editor->p1,editor->dlist)
	  && editor->p1pos > 0)
	    if (editor->offset+editor->pos <= editor->p1pos)
	      editor->p1pos-=indent;

	if (editor->p2
	  && WBDListIsPtrEqual(editor->p2,editor->dlist)
	  && editor->p2pos > 0)
	    if (editor->offset+editor->pos <= editor->p2pos)
	      editor->p2pos-=indent;

	if (editor->p1 && editor->p2
	  && WBDListIsPtrEqual(editor->p1,editor->p2)
	  && editor->p1pos >= editor->p2pos)
	    CloseBlock(editor);

	if (editor->pos > 0)
	  {
	    editor->pos-=indent;
	    UpdateCoordinates(editor,editor->row,editor->row);
	  }
	else
	  {
	    editor->offset-=indent;
	    UpdateCoordinates(editor,0,MAXROW-1);
	  }

	editor->changed = editor->realloc = 1;

	return(1);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void KeyInsert(EDITOR *editor)
  {
    if (editor->insert)
      editor->insert = 0;
    else
      editor->insert = 1;
    UpdateStats(editor,1);
  }

/***************************************************************************\
**
\***************************************************************************/
void KeyHome(EDITOR *editor, int shift)
  {
    unsigned int ptrbits;

    if (editor->pos || editor->offset)
      {
	if (shift)
	  if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	    || (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	    {
	      ptrbits = PTR1;
	      SetBlock(editor);
	    }

	editor->pos = 0;
	if (editor->offset)
	  {
	    editor->offset = 0;
	    UpdateCoordinates(editor,0,MAXROW-1);
	  }

	if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
	  SetBlkPtrs(editor,ptrbits);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void KeyEnd(EDITOR *editor, int shift)
  {
    unsigned int ptrbits;

    if (shift)
      if ((ptrbits = ChkBlkPtrs(editor)) == NOPTRS
	|| (ptrbits&PTR1) == 0 && (ptrbits&PTR2) == 0)
	{
	  ptrbits = PTR2;
	  SetBlock(editor);
	}

    while (*(editor->str+1) && *(editor->str+strlen(editor->str+1)) == ' ')
	*(editor->str+strlen(editor->str+1)) = '\0';

    if (strlen(editor->str+1) < MAXCOL)
      {
	editor->pos = strlen(editor->str+1);
	if (editor->offset)
	  {
	    editor->offset = 0;
	    UpdateCoordinates(editor,0,MAXROW-1);
	  }
      }
    else
      {
	editor->pos = MAXCOL-1;
	editor->offset = strlen(editor->str+1)-MAXCOL+1;
	UpdateCoordinates(editor,0,MAXROW-1);
      }

    if (shift && ((ptrbits&PTR1) || (ptrbits&PTR2)))
      SetBlkPtrs(editor,ptrbits);
  }

/***************************************************************************\
**
\***************************************************************************/
void KeyTab(EDITOR *editor)
  {
    int i;
    char str[256];

    if (editor->insert)
      {
	i = (int) strchr(editor->tabstr+editor->offset+editor->pos,'T') - (int) (editor->tabstr+editor->offset+editor->pos) + 1;
	*(str+i) = '\0';
	memset(str,' ',i);
	insstr(editor->str+1+editor->offset+editor->pos,str,0);

	if (editor->p1
	  && WBDListIsPtrEqual(editor->p1,editor->dlist)
	  && editor->offset+editor->pos < editor->p1pos)
	  editor->p1pos+=i;

	if (editor->p2
	  && WBDListIsPtrEqual(editor->p2,editor->dlist)
	  && editor->offset+editor->pos < editor->p2pos)
	  editor->p2pos+=i;

	editor->changed = editor->realloc = 1;
      }
    else
      {
	i = (int) strchr(editor->tabstr+editor->offset+editor->pos,'T') - (int) (editor->tabstr+editor->offset+editor->pos) + 1;
	if (editor->offset+editor->pos+i > (int) strlen(editor->str+1))
	  {
	    editor->realloc = 1;
	    *(editor->str+1+editor->offset+editor->pos+i) = '\0';
	  }
	memset(editor->str+1+editor->offset+editor->pos,' ',i);
	editor->changed = 1;
      }
    if (editor->pos + i < MAXCOL-1)
      {
	editor->pos+=i;
	UpdateCoordinates(editor,editor->row,editor->row);
      }
    else
      {
	editor->offset+=i;
	UpdateCoordinates(editor,0,MAXROW-1);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void ProcessChar(EDITOR *editor)
  {
    char istr[2];

    editor->key = 0;

    editor->backout.key = editor->ch;
    editor->backout.overkey = *(editor->str+1+editor->pos+editor->offset);
    editor->backout.pos = editor->pos;
    editor->backout.offset = editor->offset;
    editor->backout.linenum = editor->linenum;

    if (editor->insert)
      {
	if (strlen(editor->str+1) < MAXSTR-1)
	  {
	    if (editor->p1
	      && WBDListIsPtrEqual(editor->p1,editor->dlist)
	      && editor->offset+editor->pos < editor->p1pos)
	      editor->p1pos++;

	    if (editor->p2
	      && WBDListIsPtrEqual(editor->p2,editor->dlist)
	      && editor->offset+editor->pos < editor->p2pos)
	      editor->p2pos++;

	    *istr = (char) editor->ch;
	    *(istr+1) = '\0';
	    insstr(editor->str+1+editor->offset+editor->pos,istr,0);
	    editor->changed = editor->realloc = 1;
	    UpdateCoordinates(editor,editor->row,editor->row);
	    editor->key = KEY_RIGHT;

	    BITON(editor->backout.flags,BK_INSERT);
	    AddBackout(editor);
	  }
      }
    else
      {
	if ((editor->pos+editor->offset) < MAXSTR-1)
	  {
	    editor->changed = 1;
	    if (*(editor->str+1+editor->offset+editor->pos) == '\0')
	      {
		*(editor->str+2+editor->offset+editor->pos) = '\0';
		editor->realloc = 1;
	      }
	    *(editor->str+1+editor->offset+editor->pos) = (char) editor->ch;
	    editor->key = KEY_RIGHT;
	    UpdateCoordinates(editor,editor->row,editor->row);

	    AddBackout(editor);
	  }
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void ProcessKey(EDITOR *editor)
  {
    editor->ch = GetKey(editor);
    if (editor->macro_on)
      AddToMacro(editor,editor->ch);
    if (editor->ch > 31 && editor->ch < 127)
      ProcessChar(editor);
    else editor->key = editor->ch;
  }

void KeyTopOfWindow(EDITOR *editor)
  {
    if (editor->row > 0)
      {
	if (editor->changed)
	  UpdateCurrent(editor);

	while (editor->row)
	  {
	    editor->row--;
	    editor->linenum--;
	    WBDListGet(editor->dlist,WB_PREV);
	  }

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);
      }
  }

void KeyBottomOfWindow(EDITOR *editor)
  {
    if (editor->row < MAXROW-1
      && (WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	if (editor->changed)
	  UpdateCurrent(editor);

	while (editor->row < MAXROW-1
	  && (WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
	  {
	    editor->row++;
	    editor->linenum++;
	    WBDListGet(editor->dlist,WB_NEXT);
	  }

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);
      }
  }

int KeyScrollUp(EDITOR *editor)
  {
    if ((WBDListIs(editor->dltopscr)&WB_FIRST) != WB_FIRST)
      {
	if (editor->changed)
	  UpdateCurrent(editor);

	editor->linenum--;
	WBDListGet(editor->dlist,WB_PREV);
	WBDListGet(editor->dltopscr,WB_PREV);

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);
	return(1);
      }
    return(0);
  }

int KeyScrollDown(EDITOR *editor)
  {
    if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	if (editor->changed)
	  UpdateCurrent(editor);

	editor->linenum++;
	WBDListGet(editor->dlist,WB_NEXT);
	WBDListGet(editor->dltopscr,WB_NEXT);

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);
	return(1);
      }
    return(0);
  }

int KeyDeleteLine(EDITOR *editor)
  {
    int setp1 = 0, setp2 = 0;

    if ((WBDListIs(editor->dlist)&WB_LAST) != WB_LAST)
      {
	if (WBDListIsPtrEqual(editor->dlist,editor->p1))
	  setp1 = 1;

	if (WBDListIsPtrEqual(editor->dlist,editor->p2))
	  setp2 = 1;

	WBDListDelete(editor->dlist,WB_CURRENT);
	editor->chgmade = 1;

	if (setp1)
	  {
	    WBDListSetPtrEqual(editor->p1,editor->dlist);
	    editor->p1pos = 0;
	  }

	if (setp2)
	  {
	    WBDListSetPtrEqual(editor->p2,editor->dlist);
	    editor->p2pos = 0;
	  }

	if (WBDListIsPtrEqual(editor->p1,editor->p2))
	  CloseBlock(editor);

	if (editor->p1)
	  if (editor->linenum < editor->p1line)
	    editor->p1line--;

	if (editor->p2)
	  if (editor->linenum < editor->p2line)
	      editor->p2line--;

	UpdateCoordinates(editor,0,MAXROW-1);
	LineMove(editor);

	return(1);
      }
    return(0);
  }

void KeyDeleteEOL(EDITOR *editor)
  {
    *(editor->str+editor->offset+editor->pos+1) = '\0';
    editor->changed = editor->realloc = 1;
    UpdateCoordinates(editor,editor->row,editor->row);

    if (editor->p1
      && WBDListIsPtrEqual(editor->p1,editor->dlist)
      && editor->offset+editor->pos < editor->p1pos)
      editor->p1pos = editor->offset+editor->pos;

    if (editor->p2
      && WBDListIsPtrEqual(editor->p2,editor->dlist)
      && editor->offset+editor->pos < editor->p2pos)
      editor->p2pos = editor->offset+editor->pos;
  }

int KeyDeleteWord(EDITOR *editor)
  {
    char *strptr1, *strptr2;
    unsigned int ptrbits;
    int rval;

    if (*(editor->str+1+editor->offset+editor->pos) != '\0')
      {
	strptr1 = strptr2 = (editor->str+editor->offset+editor->pos+1);

	while (*(strptr2)
	  && strchr(editor->delims,*(strptr2)) == NULL)
	    strptr2++;

	while (*(strptr2)
	  && strchr(editor->delims,*(strptr2)))
	    strptr2++;

	strcpy(strptr1,strptr2);
	editor->changed = editor->realloc = 1;
	UpdateCoordinates(editor,editor->row,editor->row);
	rval = 1;
      }
    else rval = KeyDelete(editor);

    return(rval);
  }

void KeyInsertLine(EDITOR *editor)
  {
    int insert, offset, pos;

    insert = editor->insert;
    editor->insert = 1;
    pos = editor->pos;
    offset = editor->offset;
    KeyEnter(editor);
    KeyUp(editor,0);
    editor->insert = insert;
    editor->pos = pos;
    editor->offset = offset;
  }

void AutoIndent(EDITOR *editor)
  {
    editor->indent = editor->indent ? 0 : 1;
    UpdateStats(editor,1);
  }

void SearchBack(EDITOR *editor)
  {
    if (*editor->srchoptions&SRCH_FORWARD)
      *editor->srchoptions ^= SRCH_FORWARD;
    else
      *editor->srchoptions |= SRCH_FORWARD;

    UpdateStats(editor,1);
  }

int KeyGotoLine(EDITOR *editor)
  {
    WBDLIST *listptr, *topptr;
    char newlinestr[11];
    int rval = 1, row = 0;
    long linenum = 0, newlinenum;

    reversevideo();
    window(1,1,MAXSCRCOL,MAXSCRROW);
    gotoxy(1,24);
    scrprintf("Line number? ");
    clreol();
    *newlinestr = 10;
    cgets(newlinestr);
    newlinenum = atol(newlinestr+2);

    if ((listptr = WBDListPointer(editor->dlist)) != NULL)
      if ((topptr = WBDListPointer(editor->dltopscr)) != NULL)
	{
	  WBDListGet(listptr,WB_FIRST);
	  WBDListGet(topptr,WB_FIRST);
	  while (linenum != newlinenum-1
	    && (WBDListIs(listptr)&WB_LAST) != WB_LAST)
	    {
	      WBDListGet(listptr,WB_NEXT);
	      linenum++;
	      if (row < (MAXROW-1)/2)
		row++;
	      else
		WBDListGet(topptr,WB_NEXT);
	    }
	  if (linenum == newlinenum-1)
	    {
	      WBDListSetPtrEqual(editor->dlist,listptr);
	      WBDListSetPtrEqual(editor->dltopscr,topptr);
	      editor->row = row;
	      editor->linenum = linenum;
	      LineMove(editor);
	      UpdateCoordinates(editor,0,MAXROW-1);
              rval = 0;
	    }
	  WBDListClose(listptr);
	  WBDListClose(topptr);
	}
      else WBDListClose(listptr);

    UpdateStats(editor,1);
    window(1,1,MAXSCRCOL,MAXROW);
    normvideo();

    return(rval);
  }
