/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

#include "../../memsl.h"
#include "port.h"
#include "vedt.h"
#include "getkey.h"

/***************************************************************************\
**
\***************************************************************************/
void Macro(EDITOR *editor)
  {
    if (editor->macro_on)
      editor->macro_on = 0;
    else if (editor->macro)
      {
	WBSListDelete(editor->macro,WB_CLEAR);
	editor->macro_on = 1;
      }
    UpdateStats(editor,1);
  }

/***************************************************************************\
**
\***************************************************************************/
int AddToMacro(EDITOR *editor, int keycombo)
  {
    if (editor->macro && editor->macro_on)
      if (keycombo != KEY_MACRO)
	return(WBSListAdd(editor->macro,(void *)keycombo,WB_LAST));

    return(0);
  }

/***************************************************************************\
**
\***************************************************************************/
void AbortMacro(EDITOR *editor)
  {
    int ch;

    if (editor->macro && editor->macro_exe)
      {
	while (WBQueuePop(editor->keybuff,&ch));
	editor->macro_block = editor->macro_exe = 0;
	UpdateStats(editor,1);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void ExecuteMacro(EDITOR *editor)
  {
    int key;

    if (editor->macro
      && (WBSListIs(editor->macro)&WB_EMPTY) != WB_EMPTY)
      {
	editor->macro_on = 0;
	editor->macro_exe = 1;
	key = (int) WBSListGet(editor->macro,WB_FIRST);
	while (key != 0)
	  {
	    WBQueuePush(editor->keybuff,&key);
	    key = (int) WBSListGet(editor->macro,WB_NEXT);
	  }
	UpdateStats(editor,1);
      }
  }

/***************************************************************************\
**
\***************************************************************************/
void ExecuteMacroBlock(EDITOR *editor)
  {
    if (editor->hideblock == 0
      && editor->p1
      && editor->p2
      && (WBSListIs(editor->macro)&WB_EMPTY) != WB_EMPTY)
      {
	editor->macro_on = 0;
	editor->macro_exe = 1;
	editor->macro_block = 1;
	if (editor->linenum < editor->p1line
	  || editor->linenum >= editor->p2line)
	    MoveToLine(editor,editor->p1);
	ExecuteMacro(editor);
      }
  }

void ReadMacro(EDITOR *editor)
  {
    FILE *file;
    char *envstr, newfile[MAXSTR+1];
    unsigned int key;

    normvideo();
    clrscr();
    scrprintf("Read Macro Filename: ");
    newfile[0] = (char) MAXSTR-2;
    cgets(newfile);

    if (strchr(newfile+2,'/') == NULL && strchr(newfile+2,'\\') == NULL)
      if ((envstr = getenv("VEDTMACRO")) != NULL
	&& strlen(envstr) + strlen(newfile+2) + 1 < MAXSTR)
	{
	  while (strchr(envstr,'\\'))
	    *(strchr(envstr,'\\')) = '/';
	  if (*(envstr+strlen(envstr)-1) != '/')
	    insstr(newfile+2,"/",0);
	  insstr(newfile+2,envstr,0);
	}

    if (editor->macro)
      WBSListDelete(editor->macro,WB_CLEAR);

    if ((file = fopen(newfile+2,"rb")) != NULL)
      {
	editor->macro_on = 1;
	while (! ferror(file) && ! feof(file))
	  {
	    if (fread(&key,1,sizeof(int),file))
	      AddToMacro(editor,key);
	  }
	editor->macro_on = 0;
	fclose(file);
      }
    UpdateCoordinates(editor,0,MAXROW-1);
    UpdateStats(editor,1);
  }

void WriteMacro(EDITOR *editor)
  {
    FILE *file;
    char *envstr, newfile[MAXSTR+1];
    int key;

    normvideo();
    clrscr();
    scrprintf("Write Macro Filename: ");
    newfile[0] = (char) MAXSTR-2;
    cgets(newfile);

    if (strchr(newfile+2,'/') == NULL && strchr(newfile+2,'\\') == NULL)
      if ((envstr = getenv("VEDTMACRO")) != NULL
	&& strlen(envstr) + strlen(newfile+2) + 1 < MAXSTR)
	{
	  while (strchr(envstr,'\\'))
	    *(strchr(envstr,'\\')) = '/';
	  if (*(envstr+strlen(envstr)-1) != '/')
	    insstr(newfile+2,"/",0);
	  insstr(newfile+2,envstr,0);
	}

    if ((file = fopen(newfile+2,"wb")) != NULL)
      {
	key = (int) WBSListGet(editor->macro,WB_FIRST);
	while (! ferror(file) && key != 0)
	  {
	    fwrite(&key,1,sizeof(int),file);
	    key = (int) WBSListGet(editor->macro,WB_NEXT);
	  }
	fclose(file);
      }
    UpdateCoordinates(editor,0,MAXROW-1);
  }
