/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#ifdef WBSTDC
#  include <stdarg.h>
#else
#  include <varargs.h>
#endif

static int fg, bg;

/*****************************************************************************\
** Microsoft Portability
\*****************************************************************************/

#ifdef MSC

#include <graph.h>

void mscclreol(void)
  {
    short r1, r2, c1, c2;
    struct rccoord textpos;

    _gettextwindow(&r1,&c1,&r2,&c2);
    textpos = _gettextposition();
    _settextwindow(textpos.row,textpos.col,textpos.row,c2);
    _clearscreen(_GWINDOW);
    _settextwindow(r1,c1,r2,c2);
    _settextposition(textpos.row,textpos.col);
  }

int mscwherex(void)
  {
    return((_gettextposition()).col);
  }

void mscnormvideo(void)
  {
    _settextcolor(fg);
    _setbkcolor((long) bg);
  }

unsigned long coreleft()
  {
    return(10000UL);
  }

#endif


/*****************************************************************************\
** Common Portability
\*****************************************************************************/

#ifdef WBSTDC
  void initscreen(void)
#else
  void initscreen()
#endif
  {
#ifdef BORLANDC
    struct text_info tinfo;

    gettextinfo(&tinfo);
    bg = (tinfo.attribute&0x00f0)>>4;
    fg = (tinfo.attribute&0x000f);
#elif defined(MSC)
    bg = (int) _getbkcolor();
    fg = _gettextcolor();
#endif
  }

#ifdef WBSTDC
  void reversevideo(void)
#else
  void reversevideo()
#endif
  {
#if defined(BORLANDC)
    textattr(((fg>8)?(fg-8):(fg)<<4)+bg);
#elif defined(MSC)
    _settextcolor(bg);
    _setbkcolor((long) fg);
#endif
  }

#ifdef WBSTDC
  void scrprintf(char *format, ...)
#else
  void scrprintf(format, va_alist)
    char *format;
    va_dcl
#endif
  {
    va_list args;
    char comment[256];

#ifdef WBSTDC
    va_start(args,format);
#else
    va_start(args);
#endif
    memset(comment,0,256);
    if (format)
      {
        vsprintf(comment,format,args);
#if defined(BORLANDC)
        cputs(comment);
#elif defined(MSC)
        _outtext(comment);
#endif
      }
    va_end(args);
  }
