/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>

#include "../../memsl.h"
#include "port.h"
#include "vedt.h"

char *srchstrstr(char *str1, char *str2, int ignorecase)
  {
    if (ignorecase)
      return(wbstrstri(str1,str2));
    else
      return(wbstrstr(str1,str2));
  }

int srchstrncmp(char *str1, char *str2, int len, int ignorecase)
  {
    if (ignorecase)
      return(wbstrncmpi(str1,str2,len));
    else
      return(wbstrncmp(str1,str2,len));
  }

/***************************************************************************\
**
\***************************************************************************/
int SearchForward(EDITOR *editor)
  {
    WBDLIST *dlistptr, *dltopptr;
    char *chptr;
    int pos = editor->pos, row = editor->row;
    int found = 0, drawscr = 0;
    long linenum = editor->linenum;

    if ((dlistptr = WBDListPointer(editor->dlist)) != NULL)
      if ((dltopptr = WBDListPointer(editor->dltopscr)) != NULL)
        {
          chptr = WBDListGet(dlistptr,WB_CURRENT);
	  if (srchstrncmp(chptr+1+editor->offset+pos,
            editor->searchstr+2,
            strlen(editor->searchstr+2),
            (*editor->srchoptions&SRCH_IGNORECASE)) == 0)
              pos++;
	  if (srchstrstr(chptr+1+editor->offset+pos,
            editor->searchstr+2,
            (*editor->srchoptions&SRCH_IGNORECASE)))
	      found = 1;
	  else pos = 0;
          while (!found && (WBDListIs(dlistptr)&WB_LAST) != WB_LAST)
            {
              linenum++;
              chptr = WBDListGet(dlistptr,WB_NEXT);
              if (row < MAXROW-1)
                row++;
              else
                {
                  WBDListGet(dltopptr,WB_NEXT);
                  drawscr = 1;
		}
	      if (srchstrstr(chptr+1,
                editor->searchstr+2,
                (*editor->srchoptions&SRCH_IGNORECASE)))
                {
                  if (editor->offset || drawscr)
                    {
                      editor->offset = 0;
                      drawscr = 1;
                    }
		  found = 1;
		}
            }
          if (found)
            {
              editor->pos = pos;
              WBDListSetPtrEqual(editor->dltopscr,dltopptr);
              WBDListSetPtrEqual(editor->dlist,dlistptr);
              editor->linenum = linenum;
              editor->row = row;
              while (srchstrncmp(chptr+1+editor->pos+editor->offset,
                editor->searchstr+2,
                strlen(editor->searchstr+2),
                (*editor->srchoptions&SRCH_IGNORECASE)))
                {
		  if (editor->pos < MAXCOL-1)
                    editor->pos++;
                  else
                    {
                      editor->offset++;
                      drawscr = 1;
                    }
                }
	      if (editor->pos == MAXCOL-1)
		{
                  editor->offset+=strlen(editor->searchstr+2);
                  editor->pos-=strlen(editor->searchstr+2);
		}
              LineMove(editor);
            }
          WBDListClose(dlistptr);
          WBDListClose(dltopptr);
        }
      else WBDListClose(dlistptr);
    if (drawscr)
      UpdateCoordinates(editor,0,MAXROW-1);
    return(found);
  }

/***************************************************************************\
**
\***************************************************************************/
int SearchBackward(EDITOR *editor)
  {
    WBDLIST *dlistptr, *dltopptr;
    char *chptr;
    int pos = editor->pos, row = editor->row;
    int found = 0, drawscr = 0;
    long linenum = editor->linenum;

    if ((dlistptr = WBDListPointer(editor->dlist)) != NULL)
      if ((dltopptr = WBDListPointer(editor->dltopscr)) != NULL)
        {
          chptr = WBDListGet(dlistptr,WB_CURRENT);
	  if (srchstrstr(chptr+1,
            editor->searchstr+2,
            (*editor->srchoptions&SRCH_IGNORECASE)))
	      if ((int)(srchstrstr(chptr+1,
                editor->searchstr+2,
                (*editor->srchoptions&SRCH_IGNORECASE))-chptr+1) < editor->offset+pos)
                  found = 1;
          if (!found)
            pos = 0;
          while (!found && (WBDListIs(dlistptr)&WB_FIRST) != WB_FIRST)
            {
              linenum--;
              chptr = WBDListGet(dlistptr,WB_PREV);
	      if (row > 0)
		row--;
              else
                {
		  WBDListGet(dltopptr,WB_PREV);
                  drawscr = 1;
                }
	      if (srchstrstr(chptr+1,
                editor->searchstr+2,
                (*editor->srchoptions&SRCH_IGNORECASE)))
                {
                  if (editor->offset || drawscr)
                    {
                      editor->offset = 0;
                      drawscr = 1;
                    }
                  found = 1;
                }
            }
          if (found)
            {
              editor->pos = pos;
	      WBDListSetPtrEqual(editor->dltopscr,dltopptr);
	      WBDListSetPtrEqual(editor->dlist,dlistptr);
              editor->linenum = linenum;
              editor->row = row;
	      if (editor->pos == 0 && editor->offset == 0)
                {
                  editor->pos = strlen(chptr+1);
                  if (editor->pos > MAXCOL-strlen(editor->searchstr+2))
                    {
                      editor->offset = strlen(chptr+1) - (MAXCOL-strlen(editor->searchstr+2));
                      editor->pos-=editor->offset;
                      drawscr = 1;
                    }
                }
              else
                {
                  if (editor->pos)
                    editor->pos--;
                  else editor->offset--;
                }
	      while ((editor->pos || editor->offset)
                && srchstrncmp(chptr+1+editor->pos+editor->offset,
                editor->searchstr+2,
                strlen(editor->searchstr+2),
                (*editor->srchoptions&SRCH_IGNORECASE)))
		{
                  if (editor->pos)
                    editor->pos--;
		  else
		    {
                      editor->offset--;
                      drawscr = 1;
                    }
                }
              if (editor->offset)
		if (editor->offset+editor->pos < MAXCOL-strlen(editor->searchstr+2))
                  {
                    editor->pos+=editor->offset;
		    editor->offset = 0;
                    drawscr = 1;
                  }
              LineMove(editor);
            }
          WBDListClose(dlistptr);
	  WBDListClose(dltopptr);
	}
      else WBDListClose(dlistptr);
    if (drawscr)
      UpdateCoordinates(editor,0,MAXROW-1);
    return(found);
  }

/***************************************************************************\
**
\***************************************************************************/
int Search(EDITOR *editor, int searchfirst)
  {
    int rval = 0, option;

    reversevideo();
    window(1,1,MAXSCRCOL,MAXSCRROW);
    if (editor->changed)
      UpdateCurrent(editor);
    if (searchfirst)
      {
	gotoxy(1,24);
	scrprintf("Search for? ");
	clreol();
	*editor->searchstr = MAXSRCHSTR;
	cgets(editor->searchstr);

	*editor->srchoptions = 0;
	gotoxy(1,25);
	scrprintf("Search global or from cursor (G/F)? ");
	clreol();
	do { option = getch(); } while (strchr("gfGF",option) == NULL);
	if (toupper(option) == 'G')
	  {
	    KeyControlPageUp(editor, 0);
	    normvideo();
	    Draw(editor);
	    reversevideo();
	  }

	gotoxy(1,25);
	scrprintf("Search forward or backward (F/B)? ");
	clreol();
	do { option = getch(); } while (strchr("fbFB",option) == NULL);
	if (toupper(option) == 'F')
	  *editor->srchoptions |= SRCH_FORWARD;

	gotoxy(1,25);
	scrprintf("Ignore case (Y/N)? ");
	clreol();
	do { option = getch(); } while (strchr("ynYN",option) == NULL);
	if (toupper(option) == 'Y')
	  *editor->srchoptions|=SRCH_IGNORECASE;

	UpdateStats(editor,1);
	window(1,1,MAXSCRCOL,MAXSCRROW);
	reversevideo();
      }
    else
      {
	gotoxy(68,24);
	scrprintf("Searching...");
      }
    if (((*editor->srchoptions&SRCH_FORWARD)
	 ?SearchForward(editor)
	 :SearchBackward(editor)) == 0)
      {
	gotoxy(68,24);
	scrprintf("   Not found!");
      }
    else
      {
        gotoxy(68,24);
        scrprintf("Found string!");
	rval = 1;
      }
    window(1,1,MAXSCRCOL,MAXROW);
    normvideo();
    return(rval);
  }

int SearchReplace(EDITOR *editor)
  {
    char replacestr[MAXSRCHSTR];
    int option, done = 0, replaceok = 0, searchfirst = 1;

    while (((*editor->srchoptions&SRCH_REPLACEALL) || searchfirst)
      && done == 0
      && Search(editor,searchfirst))
      {
	Draw(editor);
	reversevideo();
	gotoxy(1+editor->pos,1+editor->row);
	scrprintf("%*.*s",strlen(editor->searchstr+2),strlen(editor->searchstr+2),editor->str+1+editor->pos+editor->offset);
	window(1,1,MAXSCRCOL,MAXSCRROW);

	if (searchfirst)
	  {
	    gotoxy(1,24);
	    scrprintf("Replace with? ");
	    clreol();
	    *replacestr = MAXSRCHSTR;
	    cgets(replacestr);

	    gotoxy(1,25);
	    scrprintf("Find and replace all (Y/N)? ");
	    clreol();
	    do { option = getch(); } while (strchr("ynYN",option) == NULL);
	    if (toupper(option) == 'Y')
	      *editor->srchoptions |= SRCH_REPLACEALL;

	    gotoxy(1,25);
	    scrprintf("Prompt on replace (Y/N)? ");
	    clreol();
	    do { option = getch(); } while (strchr("ynYN",option) == NULL);
	    if (toupper(option) == 'Y')
	      *editor->srchoptions |= SRCH_PROMPT;
	  }

	if (*editor->srchoptions&SRCH_PROMPT)
	  {
	    replaceok = 0;
	    gotoxy(1,25);
	    scrprintf("(Q)uit, Replace (a)ll, Replace (Y/N)? ");
	    clreol();
	    do { option = getch(); } while (strchr("aAynYNqQ",option) == NULL);
	    if (toupper(option) == 'Y')
	      replaceok = 1;
	    else if (toupper(option) == 'A')
	      *editor->srchoptions^=SRCH_PROMPT;
	    else if (toupper(option) == 'Q')
	      done = 1;
	  }
	else replaceok = 1;

	normvideo();
	gotoxy(1+editor->pos,1+editor->row);
	scrprintf("%*.*s",strlen(editor->searchstr+2),strlen(editor->searchstr+2),editor->str+1+editor->pos+editor->offset);

	if (replaceok)
	  {
	    strcpy(editor->str+1+editor->pos+editor->offset,
		   editor->str+1+editor->pos+editor->offset+strlen(editor->searchstr+2));
	    insstr(editor->str+1+editor->pos+editor->offset,
		   replacestr+2,0);
	    editor->changed = editor->realloc = 1;
	    UpdateCurrent(editor);
	    UpdateCoordinates(editor,0,MAXROW-1);
	  }

	searchfirst = 0;
      }

    UpdateStats(editor,1);
    window(1,1,MAXSCRCOL,MAXROW);
    normvideo();
    return(searchfirst);
  }
